## com.baidubce.http
Class IdleConnectionReaper

    java.lang.Object
      java.lang.Thread
          com.baidubce.http.IdleConnectionReaper

All Implemented Interfaces:
  Runnable

    public final class IdleConnectionReaper

extends Thread

Daemon thread to periodically check connection pools for idle connections.

Connections sitting around idle in the HTTP connection pool for too long will eventually be terminated by the BCE end of the connection, and will go into CLOSE_WAIT. If this happens, sockets will sit around in CLOSE_WAIT, still using resources on the client side to manage that socket. Many sockets stuck in CLOSE_WAIT can prevent the OS from creating new connections.

This class closes idle connections before they can move into the CLOSE_WAIT state.

This thread is important because by default, we disable Apache HttpClient's stale connection checking, so without this thread running in the background, cleaning up old/inactive HTTP connections, we'd see more IO exceptions when stale connections (i.e. closed on the BCE side) are left in the connection pool, and requests grab one of them to begin executing a request.

Nested Class Summary

Nested classes/interfaces inherited from class java.lang.Thread
`Thread.State, Thread.UncaughtExceptionHandler`

Field Summary

Fields inherited from class java.lang.Thread
`MAX_PRIORITY, MIN_PRIORITY, NORM_PRIORITY`

Method Summary
`static boolean` `registerConnectionManager(org.apache.http.conn.HttpClientConnectionManager connectionManager)` Registers the given connection manager with this reaper;
`static boolean` `removeConnectionManager(org.apache.http.conn.HttpClientConnectionManager connectionManager)` Removes the given connection manager from this reaper, and shutting down the reaper if there is zero connection manager left.
`void` `run()`
`static boolean` `shutdown()` Shuts down the thread, allowing the class and instance to be collected.

Methods inherited from class java.lang.Thread

`activeCount, checkAccess, clone, countStackFrames, currentThread, destroy, dumpStack, enumerate, getAllStackTraces, getContextClassLoader, getDefaultUncaughtExceptionHandler, getId, getName, getPriority, getStackTrace, getState, getThreadGroup, getUncaughtExceptionHandler, holdsLock, interrupt, interrupted, isAlive, isDaemon, isInterrupted, join, join, join, resume, setContextClassLoader, setDaemon, setDefaultUncaughtExceptionHandler, setName, setPriority, setUncaughtExceptionHandler, sleep, sleep, start, stop, stop, suspend, toString, yield`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### registerConnectionManager

    public static boolean registerConnectionManager(org.apache.http.conn.HttpClientConnectionManager connectionManager)

  Registers the given connection manager with this reaper;

  Returns:
    true if the connection manager has been successfully registered; false otherwise.

### removeConnectionManager

    public static boolean removeConnectionManager(org.apache.http.conn.HttpClientConnectionManager connectionManager)

  Removes the given connection manager from this reaper, and shutting down the reaper if there is zero connection manager left.

  Returns:
    true if the connection manager has been successfully removed; false otherwise.

### run

    public void run()

  Specified by:
    `run` in interface `Runnable`
  Overrides:
    `run` in class `Thread`

### shutdown

    public static boolean shutdown()

  Shuts down the thread, allowing the class and instance to be collected.

  Since this is a daemon thread, its running will not prevent JVM shutdown. It will, however, prevent this class from being unloaded or garbage collected, in the context of a long-running application, until it is interrupted. This method will stop the thread's execution and clear its state. Any use of a service client will cause the thread to be restarted.

  Returns:
    true if an actual shutdown has been made; false otherwise.

Copyright © 2016. All rights reserved.